#version 140
#extension GL_EXT_gpu_shader4 : enable

// More colors more spiralsMod01.fsh by mrange
//https://www.shadertoy.com/view/sdsBWs
// CC0: More colors, more spirals
// Been tinkering withs spirals for a few days so why stop now
// Licence CC0
// Adapted, trivialy, for use in VGHD player

uniform float u_Elapsed;    // The elapsed time in seconds
uniform vec2  u_WindowSize; // Window dimensions in pixels
uniform sampler2D iChannel0;


#define RESOLUTION  u_WindowSize  //iResolution
#define TIME        u_Elapsed* 0.3141592  // iTime
#define iResolution RESOLUTION 
#define iTime TIME 











#define PI          3.141592654
#define TAU         (2.0*PI)
#define ROT(a)      mat2(cos(a), sin(a), -sin(a), cos(a))

const vec4 hsv2rgb_K = vec4(1.0, 2.0 / 3.0, 1.0 / 3.0, 3.0);
// License: WTFPL, author: sam hocevar, found: https://stackoverflow.com/a/17897228/418488
vec3 hsv2rgb(vec3 c) {
  vec3 p = abs(fract(c.xxx + hsv2rgb_K.xyz) * 6.0 - hsv2rgb_K.www);
  return c.z * mix(hsv2rgb_K.xxx, clamp(p - hsv2rgb_K.xxx, 0.0, 1.0), c.y);
}

// License: Unknown, author: nmz (twitter: @stormoid), found: https://www.shadertoy.com/view/NdfyRM
float sRGB(float t) { return mix(1.055*pow(t, 1./2.4) - 0.055, 12.92*t, step(t, 0.0031308)); }
// License: Unknown, author: nmz (twitter: @stormoid), found: https://www.shadertoy.com/view/NdfyRM
vec3 sRGB(in vec3 c) { return vec3 (sRGB(c.x), sRGB(c.y), sRGB(c.z)); }

// License: MIT, author: Inigo Quilez, found: https://www.iquilezles.org/www/articles/smin/smin.htm
float pmin(float a, float b, float k) {
  float h = clamp(0.5+0.5*(b-a)/k, 0.0, 1.0);
  return mix(b, a, h) - k*h*(1.0-h);
}

// License: MIT OR CC-BY-NC-4.0, author: mercury, found: https://mercury.sexy/hg_sdf/
vec2 mod2(inout vec2 p, vec2 size) {
  vec2 c = floor((p + size*0.5)/size);
  p = mod(p + size*0.5,size) - size*0.5;
  return c;
}

// License: Unknown, author: Unknown, found: don't remember
float tanh_approx(float x) {
  //  Found this somewhere on the interwebs
  //  return tanh(x);
  float x2 = x*x;
  return clamp(x*(27.0 + x2)/(27.0+9.0*x2), -1.0, 1.0);
}

// License: Unknown, author: Martijn Steinrucken, found: https://www.youtube.com/watch?v=VmrIDyYiJBA
vec2 hextile(inout vec2 p) {
  // See Art of Code: Hexagonal Tiling Explained!
  // https://www.youtube.com/watch?v=VmrIDyYiJBA
  const vec2 sz       = vec2(1.0, sqrt(3.0));
  const vec2 hsz      = 0.5*sz;

  vec2 p1 = mod(p, sz)-hsz;
  vec2 p2 = mod(p - hsz, sz)-hsz;
  vec2 p3 = dot(p1, p1) < dot(p2, p2) ? p1 : p2;
  vec2 n = ((p3 - p + hsz)/sz);
  p = p3;

  n -= vec2(0.5);
  // Rounding to make hextile 0,0 well behaved
  return round(n*2.0)*0.5;
}

// License: MIT, author: Inigo Quilez, found: https://iquilezles.org/www/articles/distfunctions2d/distfunctions2d.htm
float hex(vec2 p, float r ) {
  const vec3 k = vec3(-0.866025404,0.5,0.577350269);
  p = abs(p);
  p -= 2.0*min(dot(k.xy,p),0.0)*k.xy;
  p -= vec2(clamp(p.x, -k.z*r, k.z*r), r);
  return length(p)*sign(p.y);
}

// License: Unknown, author: Unknown, found: don't remember
float hash(vec2 co) {
  return fract(sin(dot(co.xy ,vec2(12.9898,58.233))) * 13758.5453);
}

vec2 toPolar(vec2 p) {
  return vec2(length(p), atan(p.y, p.x)+PI);
}

vec2 spiralEffect(vec2 p, float a, float n) {
  vec2 op = p;
  float b = a/TAU;
  vec2 pp   = toPolar(op);
  float  aa = pp.y;
  pp        -= vec2(pp.y*n*b, (pp.x/b+PI)/n);
  vec2  nn  = mod2(pp, vec2(a, TAU/n));
  // Yes, this is a trial and error:ed until it looked good 
  // because I couldn't be bothered to compute the real solution
  float xf  = tanh_approx(20.0*length(p)/abs(n));
  return vec2(abs(pp.x)*xf, mod(nn.y, n));
}


vec3 df(vec2 p) {
  float zo = mix(0.75, 1.5, smoothstep(-0.5, 0.5, -cos(TIME*sqrt(0.1))));
  
  p /= zo;

  p += 10.0*cos(0.033*TIME*vec2(1.0, sqrt(0.5)));
  
  vec2  hn = hextile(p);
  float hh = hash(hn);
  float h0 = fract(1367.0*hh);
  float h1 = fract(1777.0*hh);
  float h2 = fract(2083.0*hh);
  float h3 = fract(2711.0*hh);
  float h4 = fract(2803.0*hh);
  
  float zi = mix(0.125, 0.25, h3);

  float hd = (abs(hex(p.yx, 0.5))-0.025)*zo;
  
  p /= zi;
  
  float a = 0.5;
  float sp0 = round(mix(1.0, 23.0, h0));
  float sp1 = round(mix(1.0, 37.0, h1));
  vec2 se0 = spiralEffect(p*ROT(-0.123*TIME), a, sp0);
  vec2 se1 = spiralEffect(p*ROT(.1*TIME), a, sign(h4-0.75)*sp1);
  
  vec2 se = vec2(pmin(se0.x, se1.x, 0.025), se0.y+se1.y);
  
  float h = se.y*0.05+h2+TIME*0.2;
  float d = -((se.x)-0.05);
  d *= zi*zo;
  return vec3(d, hd, h);
}
void main (void)
//void mainImage(out vec4 fragColor, in vec2 fragCoord) 
{
  float aa = 2.0/RESOLUTION.y;
  vec2 q  = gl_FragCoord.xy/RESOLUTION.xy;
  vec2 p  = -1. + 2. * q;
  p.x     *= RESOLUTION.x/RESOLUTION.y;
  vec3 d3 = df(p);
  float d = d3.x;
  float hd= d3.y;
  float h = d3.z;
  float s = smoothstep(aa, -aa, d);
  vec3 col = vec3(0.0);
  
  col = hsv2rgb(vec3(fract(h), 0.95, s));
  col = mix(col, vec3(0.0), smoothstep(aa, -aa, hd));
  col = sRGB(col);
  gl_FragColor = vec4(col, 1.0);
}


